@ECHO OFF
REM C99C.BAT
REM
REM Batch file for x-compiling, optimizing and assembling
REM TI99/4A C99 programs
REM
REM Compiled code will be stored in the \OBJ directory
REM 
REM This batchfile is intended to be used with TotalCommander
REM  Command=		?:\Ti994w\Utl\C99c.bat
REM  Parameters=	%O %E
REM  Iconfile=		?:\Ti994w\Utl\C99c.exe
REM  Tooltip=		C99C - Cross-compiler for the TI99/4A
REM
REM Author:	Frederik G. Kaal
REM Version:	1.0
REM Data	09-11-2002
REM 
REM Call: C99C.BAT inputfile extentsion


@echo [%1] [%2] [%3] [%4] [%5]

SET SPACE=
SET PATH=D:\TI994W\UTL;%PATH%
SET VIEWER=notepad.exe

if .%2.==.c99. goto compile
if .%2.==.C99. goto compile

if .%2.==.A99. goto assemble
if .%2.==.a99. goto assemble

start /WAIT wmessage -M%1.%2 does not have the right extension\nfor compiling like .C99\nor assembling like .A99 -TC99C -K1 -I4
goto end


:assemble
REM if exist .\obj\%1.s del .\obj\%1.s
REM copy %1.%2 .\obj\%1.s >nul
CD .\obj
SET ASRC=.\..\%1.%2
goto XA99


:compile
@echo Start Compiling
if exist .\obj\%1.err del .\obj\%1.err
@echo C99C.EXE %1.%2 .\obj\%1.a99
@echo on
C99C.EXE %1.%2 .\obj\%1.a99 .\obj\%1.err /t
@echo off
CD .\OBJ
findstring "No errors found" <%1.err
if errorlevel 1 goto comperr
SET ASRC=%1.s

@echo Start Optimizing
@echo C99O.EXE %1.a99 %1.o99
C99O.EXE %1.a99 %1.o99

@echo Start X-Optimizing
@echo C99X.EXE %1.o99 %1.x99
C99X.EXE %1.o99 %1.x99

@echo Start F-Optimizing
@echo C99F.EXE %1.x99 %1.f99
C99F.EXE %1.x99 %1.f99

@echo Start M-Optimizing
@echo C99M.EXE %1.f99 %1.s
C99M.EXE %1.f99 %1.s


:XA99
@echo Start Assembling
if exist %1.aer del %1.aer
@echo XA99.EXE -i%ASRC% -o%1.x -l%1.p -v -r -S -s
XA99.EXE -i%ASRC% -o%1.x -l%1.p -v -r -S -s
if errorlevel 1 goto asmerr
goto end

:comperr
@echo Compiler errors
start /WAIT wmessage -MCompiler errors -TC99 -K1 -I4
%VIEWER% %1.ERR
set ERROR=1
goto end

:asmerr
@echo Assembler errors
start /WAIT wmessage -MAssembler errors -TXA99 -K1 -I4
REM %VIEWER% %1.AER
%VIEWER% %1.P
set ERROR=1
goto end

:end
cd ..
